#include "_gen/svc-Account_Interface_Minimum_Presence.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _mc_svc_account_interface_minimum_presence_object_info;

struct _McSvcAccountInterfaceMinimumPresenceClass {
    GTypeInterface parent_class;
    mc_svc_account_interface_minimum_presence_request_impl request;
    mc_svc_account_interface_minimum_presence_release_impl release;
};

static void mc_svc_account_interface_minimum_presence_base_init (gpointer klass);

GType
mc_svc_account_interface_minimum_presence_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (McSvcAccountInterfaceMinimumPresenceClass),
        mc_svc_account_interface_minimum_presence_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "McSvcAccountInterfaceMinimumPresence", &info, 0);
    }

  return type;
}

/**
 * mc_svc_account_interface_minimum_presence_request_impl:
 * @self: The object implementing this interface
 * @in_status: const GValueArray * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * Request on interface org.freedesktop.Telepathy.Account.Interface.MinimumPresence.DRAFT.
 */
static void
mc_svc_account_interface_minimum_presence_request (McSvcAccountInterfaceMinimumPresence *self,
    const GValueArray *in_status,
    DBusGMethodInvocation *context)
{
  mc_svc_account_interface_minimum_presence_request_impl impl = (MC_SVC_ACCOUNT_INTERFACE_MINIMUM_PRESENCE_GET_CLASS (self)->request);

  if (impl != NULL)
    {
      (impl) (self,
        in_status,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_account_interface_minimum_presence_implement_request:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Request D-Bus method
 *
 * Register an implementation for the Request method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_account_interface_minimum_presence_implement_request (McSvcAccountInterfaceMinimumPresenceClass *klass, mc_svc_account_interface_minimum_presence_request_impl impl)
{
  klass->request = impl;
}

/**
 * mc_svc_account_interface_minimum_presence_release_impl:
 * @self: The object implementing this interface
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * Release on interface org.freedesktop.Telepathy.Account.Interface.MinimumPresence.DRAFT.
 */
static void
mc_svc_account_interface_minimum_presence_release (McSvcAccountInterfaceMinimumPresence *self,
    DBusGMethodInvocation *context)
{
  mc_svc_account_interface_minimum_presence_release_impl impl = (MC_SVC_ACCOUNT_INTERFACE_MINIMUM_PRESENCE_GET_CLASS (self)->release);

  if (impl != NULL)
    {
      (impl) (self,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_account_interface_minimum_presence_implement_release:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the Release D-Bus method
 *
 * Register an implementation for the Release method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_account_interface_minimum_presence_implement_release (McSvcAccountInterfaceMinimumPresenceClass *klass, mc_svc_account_interface_minimum_presence_release_impl impl)
{
  klass->release = impl;
}

static inline void
mc_svc_account_interface_minimum_presence_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[2] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "a{s(uss)}", 0, NULL, NULL }, /* Requests */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  dbus_g_object_type_install_info (mc_svc_account_interface_minimum_presence_get_type (),
      &_mc_svc_account_interface_minimum_presence_object_info);

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.Account.Interface.MinimumPresence.DRAFT");
  properties[0].name = g_quark_from_static_string ("Requests");
  properties[0].type = (dbus_g_type_get_map ("GHashTable", G_TYPE_STRING, (dbus_g_type_get_struct ("GValueArray", G_TYPE_UINT, G_TYPE_STRING, G_TYPE_STRING, G_TYPE_INVALID))));
  tp_svc_interface_set_dbus_properties_info (MC_TYPE_SVC_ACCOUNT_INTERFACE_MINIMUM_PRESENCE, &interface);

}
static void
mc_svc_account_interface_minimum_presence_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      mc_svc_account_interface_minimum_presence_base_init_once (klass);
    }
}
static const DBusGMethodInfo _mc_svc_account_interface_minimum_presence_methods[] = {
  { (GCallback) mc_svc_account_interface_minimum_presence_request, _mcd_ext_marshal_VOID__BOXED_POINTER, 0 },
  { (GCallback) mc_svc_account_interface_minimum_presence_release, g_cclosure_marshal_VOID__POINTER, 92 },
};

static const DBusGObjectInfo _mc_svc_account_interface_minimum_presence_object_info = {
  0,
  _mc_svc_account_interface_minimum_presence_methods,
  2,
"org.freedesktop.Telepathy.Account.Interface.MinimumPresence.DRAFT\0Request\0A\0status\0I\0(uss)\0\0org.freedesktop.Telepathy.Account.Interface.MinimumPresence.DRAFT\0Release\0A\0\0\0",
"\0\0",
"\0\0",
};


