#include "_gen/svc-Account_Manager_Interface_SSO.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _mc_svc_account_manager_interface_sso_object_info;

struct _McSvcAccountManagerInterfaceSSOClass {
    GTypeInterface parent_class;
    mc_svc_account_manager_interface_sso_get_service_accounts_impl get_service_accounts;
    mc_svc_account_manager_interface_sso_get_account_impl get_account;
};

static void mc_svc_account_manager_interface_sso_base_init (gpointer klass);

GType
mc_svc_account_manager_interface_sso_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (McSvcAccountManagerInterfaceSSOClass),
        mc_svc_account_manager_interface_sso_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "McSvcAccountManagerInterfaceSSO", &info, 0);
    }

  return type;
}

/**
 * mc_svc_account_manager_interface_sso_get_service_accounts_impl:
 * @self: The object implementing this interface
 * @in_Service: const gchar * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetServiceAccounts on interface com.nokia.Telepathy.AccountManager.Interface.SSO.
 */
static void
mc_svc_account_manager_interface_sso_get_service_accounts (McSvcAccountManagerInterfaceSSO *self,
    const gchar *in_Service,
    DBusGMethodInvocation *context)
{
  mc_svc_account_manager_interface_sso_get_service_accounts_impl impl = (MC_SVC_ACCOUNT_MANAGER_INTERFACE_SSO_GET_CLASS (self)->get_service_accounts);

  if (impl != NULL)
    {
      (impl) (self,
        in_Service,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_account_manager_interface_sso_implement_get_service_accounts:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetServiceAccounts D-Bus method
 *
 * Register an implementation for the GetServiceAccounts method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_account_manager_interface_sso_implement_get_service_accounts (McSvcAccountManagerInterfaceSSOClass *klass, mc_svc_account_manager_interface_sso_get_service_accounts_impl impl)
{
  klass->get_service_accounts = impl;
}

/**
 * mc_svc_account_manager_interface_sso_get_account_impl:
 * @self: The object implementing this interface
 * @in_ID: guint  (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * GetAccount on interface com.nokia.Telepathy.AccountManager.Interface.SSO.
 */
static void
mc_svc_account_manager_interface_sso_get_account (McSvcAccountManagerInterfaceSSO *self,
    guint in_ID,
    DBusGMethodInvocation *context)
{
  mc_svc_account_manager_interface_sso_get_account_impl impl = (MC_SVC_ACCOUNT_MANAGER_INTERFACE_SSO_GET_CLASS (self)->get_account);

  if (impl != NULL)
    {
      (impl) (self,
        in_ID,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_account_manager_interface_sso_implement_get_account:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the GetAccount D-Bus method
 *
 * Register an implementation for the GetAccount method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_account_manager_interface_sso_implement_get_account (McSvcAccountManagerInterfaceSSOClass *klass, mc_svc_account_manager_interface_sso_get_account_impl impl)
{
  klass->get_account = impl;
}

static inline void
mc_svc_account_manager_interface_sso_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  dbus_g_object_type_install_info (mc_svc_account_manager_interface_sso_get_type (),
      &_mc_svc_account_manager_interface_sso_object_info);

}
static void
mc_svc_account_manager_interface_sso_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      mc_svc_account_manager_interface_sso_base_init_once (klass);
    }
}
static const DBusGMethodInfo _mc_svc_account_manager_interface_sso_methods[] = {
  { (GCallback) mc_svc_account_manager_interface_sso_get_service_accounts, _mcd_ext_marshal_VOID__STRING_POINTER, 0 },
  { (GCallback) mc_svc_account_manager_interface_sso_get_account, g_cclosure_marshal_VOID__UINT_POINTER, 101 },
};

static const DBusGObjectInfo _mc_svc_account_manager_interface_sso_object_info = {
  0,
  _mc_svc_account_manager_interface_sso_methods,
  2,
"com.nokia.Telepathy.AccountManager.Interface.SSO\0GetServiceAccounts\0A\0Service\0I\0s\0Accounts\0O\0F\0N\0ao\0\0com.nokia.Telepathy.AccountManager.Interface.SSO\0GetAccount\0A\0ID\0I\0u\0Account\0O\0F\0N\0o\0\0\0",
"\0\0",
"\0\0",
};


