#include "_gen/svc-Channel_Dispatcher_Future.h"

#include <telepathy-glib/dbus.h>
#include "_gen/signals-marshal.h"

static const DBusGObjectInfo _mc_svc_channel_dispatcher_future_object_info;

struct _McSvcChannelDispatcherFutureClass {
    GTypeInterface parent_class;
    mc_svc_channel_dispatcher_future_create_channel_with_hints_impl create_channel_with_hints;
    mc_svc_channel_dispatcher_future_ensure_channel_with_hints_impl ensure_channel_with_hints;
};

static void mc_svc_channel_dispatcher_future_base_init (gpointer klass);

GType
mc_svc_channel_dispatcher_future_get_type (void)
{
  static GType type = 0;

  if (G_UNLIKELY (type == 0))
    {
      static const GTypeInfo info = {
        sizeof (McSvcChannelDispatcherFutureClass),
        mc_svc_channel_dispatcher_future_base_init, /* base_init */
        NULL, /* base_finalize */
        NULL, /* class_init */
        NULL, /* class_finalize */
        NULL, /* class_data */
        0,
        0, /* n_preallocs */
        NULL /* instance_init */
      };

      type = g_type_register_static (G_TYPE_INTERFACE,
          "McSvcChannelDispatcherFuture", &info, 0);
    }

  return type;
}

/**
 * mc_svc_channel_dispatcher_future_create_channel_with_hints_impl:
 * @self: The object implementing this interface
 * @in_Account: const gchar * (FIXME, generate documentation)
 * @in_Requested_Properties: GHashTable * (FIXME, generate documentation)
 * @in_User_Action_Time: gint64  (FIXME, generate documentation)
 * @in_Preferred_Handler: const gchar * (FIXME, generate documentation)
 * @in_Hints: GHashTable * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * CreateChannelWithHints on interface org.freedesktop.Telepathy.ChannelDispatcher.FUTURE.
 */
static void
mc_svc_channel_dispatcher_future_create_channel_with_hints (McSvcChannelDispatcherFuture *self,
    const gchar *in_Account,
    GHashTable *in_Requested_Properties,
    gint64 in_User_Action_Time,
    const gchar *in_Preferred_Handler,
    GHashTable *in_Hints,
    DBusGMethodInvocation *context)
{
  mc_svc_channel_dispatcher_future_create_channel_with_hints_impl impl = (MC_SVC_CHANNEL_DISPATCHER_FUTURE_GET_CLASS (self)->create_channel_with_hints);

  if (impl != NULL)
    {
      (impl) (self,
        in_Account,
        in_Requested_Properties,
        in_User_Action_Time,
        in_Preferred_Handler,
        in_Hints,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_channel_dispatcher_future_implement_create_channel_with_hints:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the CreateChannelWithHints D-Bus method
 *
 * Register an implementation for the CreateChannelWithHints method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_channel_dispatcher_future_implement_create_channel_with_hints (McSvcChannelDispatcherFutureClass *klass, mc_svc_channel_dispatcher_future_create_channel_with_hints_impl impl)
{
  klass->create_channel_with_hints = impl;
}

/**
 * mc_svc_channel_dispatcher_future_ensure_channel_with_hints_impl:
 * @self: The object implementing this interface
 * @in_Account: const gchar * (FIXME, generate documentation)
 * @in_Requested_Properties: GHashTable * (FIXME, generate documentation)
 * @in_User_Action_Time: gint64  (FIXME, generate documentation)
 * @in_Preferred_Handler: const gchar * (FIXME, generate documentation)
 * @in_Hints: GHashTable * (FIXME, generate documentation)
 * @context: Used to return values or throw an error
 *
 * The signature of an implementation of the D-Bus method
 * EnsureChannelWithHints on interface org.freedesktop.Telepathy.ChannelDispatcher.FUTURE.
 */
static void
mc_svc_channel_dispatcher_future_ensure_channel_with_hints (McSvcChannelDispatcherFuture *self,
    const gchar *in_Account,
    GHashTable *in_Requested_Properties,
    gint64 in_User_Action_Time,
    const gchar *in_Preferred_Handler,
    GHashTable *in_Hints,
    DBusGMethodInvocation *context)
{
  mc_svc_channel_dispatcher_future_ensure_channel_with_hints_impl impl = (MC_SVC_CHANNEL_DISPATCHER_FUTURE_GET_CLASS (self)->ensure_channel_with_hints);

  if (impl != NULL)
    {
      (impl) (self,
        in_Account,
        in_Requested_Properties,
        in_User_Action_Time,
        in_Preferred_Handler,
        in_Hints,
        context);
    }
  else
    {
      tp_dbus_g_method_return_not_implemented (context);
    }
}

/**
 * mc_svc_channel_dispatcher_future_implement_ensure_channel_with_hints:
 * @klass: A class whose instances implement this interface
 * @impl: A callback used to implement the EnsureChannelWithHints D-Bus method
 *
 * Register an implementation for the EnsureChannelWithHints method in the vtable
 * of an implementation of this interface. To be called from
 * the interface init function.
 */
void
mc_svc_channel_dispatcher_future_implement_ensure_channel_with_hints (McSvcChannelDispatcherFutureClass *klass, mc_svc_channel_dispatcher_future_ensure_channel_with_hints_impl impl)
{
  klass->ensure_channel_with_hints = impl;
}

static inline void
mc_svc_channel_dispatcher_future_base_init_once (gpointer klass G_GNUC_UNUSED)
{
  static TpDBusPropertiesMixinPropInfo properties[2] = {
      { 0, TP_DBUS_PROPERTIES_MIXIN_FLAG_READ, "b", 0, NULL, NULL }, /* SupportsRequestHints */
      { 0, 0, NULL, 0, NULL, NULL }
  };
  static TpDBusPropertiesMixinIfaceInfo interface =
      { 0, properties, NULL, NULL };

  dbus_g_object_type_install_info (mc_svc_channel_dispatcher_future_get_type (),
      &_mc_svc_channel_dispatcher_future_object_info);

  interface.dbus_interface = g_quark_from_static_string ("org.freedesktop.Telepathy.ChannelDispatcher.FUTURE");
  properties[0].name = g_quark_from_static_string ("SupportsRequestHints");
  properties[0].type = G_TYPE_BOOLEAN;
  tp_svc_interface_set_dbus_properties_info (MC_TYPE_SVC_CHANNEL_DISPATCHER_FUTURE, &interface);

}
static void
mc_svc_channel_dispatcher_future_base_init (gpointer klass)
{
  static gboolean initialized = FALSE;

  if (!initialized)
    {
      initialized = TRUE;
      mc_svc_channel_dispatcher_future_base_init_once (klass);
    }
}
static const DBusGMethodInfo _mc_svc_channel_dispatcher_future_methods[] = {
  { (GCallback) mc_svc_channel_dispatcher_future_create_channel_with_hints, _mcd_ext_marshal_VOID__BOXED_BOXED_INT64_STRING_BOXED_POINTER, 0 },
  { (GCallback) mc_svc_channel_dispatcher_future_ensure_channel_with_hints, _mcd_ext_marshal_VOID__BOXED_BOXED_INT64_STRING_BOXED_POINTER, 191 },
};

static const DBusGObjectInfo _mc_svc_channel_dispatcher_future_object_info = {
  0,
  _mc_svc_channel_dispatcher_future_methods,
  2,
"org.freedesktop.Telepathy.ChannelDispatcher.FUTURE\0CreateChannelWithHints\0A\0Account\0I\0o\0Requested_Properties\0I\0a{sv}\0User_Action_Time\0I\0x\0Preferred_Handler\0I\0s\0Hints\0I\0a{sv}\0Request\0O\0F\0N\0o\0\0org.freedesktop.Telepathy.ChannelDispatcher.FUTURE\0EnsureChannelWithHints\0A\0Account\0I\0o\0Requested_Properties\0I\0a{sv}\0User_Action_Time\0I\0x\0Preferred_Handler\0I\0s\0Hints\0I\0a{sv}\0Request\0O\0F\0N\0o\0\0\0",
"\0\0",
"\0\0",
};


